(* Copyright (c) 2017. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: FireDAC"
     by Cary Jensen

   ISBN-13: 978-1546391272 
   ISBN-10: 1546391274

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: FireDAC"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/FireDACBook
*)
unit mainformu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf,
  FireDAC.DApt.Intf, Data.DB, Vcl.StdCtrls, Vcl.Grids, Vcl.DBGrids,
  Vcl.ExtCtrls, Vcl.DBCtrls, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  FireDAC.Stan.StorageXML;

type
  Tmainform = class(TForm)
    FDMemTable1: TFDMemTable;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    FDStanStorageXMLLink1: TFDStanStorageXMLLink;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mainform: Tmainform;

implementation

{$R *.dfm}

const
  DataFile = 'mydata.xml';

procedure Tmainform.FormCreate(Sender: TObject);
begin
//  if FileExists( DataFile ) then
//    FDMemTable1.LoadFromFile( DataFile )
//  else
//    begin
//      with FDMemTable1.FieldDefs do
//      begin
//        Clear;
//        with AddFieldDef do
//        begin
//          Name := 'First Name';
//          DataType := ftString;
//          Size := 20;
//        end; //with AddFieldDef do
//        with AddFieldDef do
//        begin
//          Name := 'Last Name';
//          DataType := ftString;
//          Size := 25;
//        end; //with AddFieldDef do
//        with AddFieldDef do
//        begin
//          Name := 'Date of Birth';
//          DataType := ftDate;
//        end; //with AddFieldDef do
//        with AddFieldDef do
//        begin
//          Name := 'Active';
//          DataType := ftBoolean;
//        end; //with AddFieldDef do
//      end; //with FDMemTable1.FieldDefs
//      FDMemTable1.CreateDataSet;
//    end;
  if FileExists( DataFile ) then
    FDMemTable1.LoadFromFile( DataFile )
  else
    begin
      with FDMemTable1.FieldDefs do
      begin
        Clear;
        Add('FirstName',ftString, 20);
        Add('LastName',ftString, 25);
        Add('DateOfBirth',ftDate);
        Add('Active',ftBoolean);
      end; //with FDMemTable1.FieldDefs
      FDMemTable1.Active := True;
    end;
end;

procedure Tmainform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FDMemTable1.Active then
    FDMemTable1.SaveToFile( DataFile );
end;

end.
