(* Copyright (c) 2017. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: FireDAC"
     by Cary Jensen

   ISBN-13: 978-1546391272 
   ISBN-10: 1546391274

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: FireDAC"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/FireDACBook
*)
unit mainformu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS,
  FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.StorageXML,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client, Vcl.Grids, Vcl.DBGrids,
  Vcl.ExtCtrls, Vcl.DBCtrls;

type
  Tmainform = class(TForm)
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    FDMemTable1: TFDMemTable;
    DataSource1: TDataSource;
    FDStanStorageXMLLink1: TFDStanStorageXMLLink;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mainform: Tmainform;

implementation

{$R *.dfm}

const
  DataFile = 'mydata.xml';

procedure Tmainform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FDMemTable1.Active then
    FDMemTable1.SaveToFile( DataFile );
end;

procedure Tmainform.FormCreate(Sender: TObject);
begin
  if FileExists( DataFile ) then
    FDMemTable1.LoadFromFile( DataFile )
  else
    begin
      with TStringField.Create(Self) do
      begin
        Name := 'FDMemTable1FirstName';
        FieldKind := fkData;
        FieldName := 'FirstName';
        Size := 20;
        DataSet := FDMemTable1;
      end; //First Name
      with TStringField.Create(Self) do
      begin
        Name := 'FDMemTable1LastName';
        FieldKind := fkData;
        FieldName := 'LastName';
        Size := 25;
        DataSet := FDMemTable1;
      end; //Last Name
      with TDateField.Create(Self) do
      begin
        Name := 'FDMemTable1DateOfBirth';
        FieldKind := fkData;
        FieldName := 'DateOfBirth';
        DataSet := FDMemTable1;
      end; //Date of Birth
      with TBooleanField.Create(Self) do
      begin
        Name := 'FDMemTable1Active';
        FieldKind := fkData;
        FieldName := 'Active';
        DataSet := FDMemTable1;
      end; //Active Name
      FDMemTable1.CreateDataSet;
    end;
end;

end.
