(* Copyright (c) 2017. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: FireDAC"
     by Cary Jensen

   ISBN-13: 978-1546391272 
   ISBN-10: 1546391274

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: FireDAC"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/FireDACBook
*)
unit mainformu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBClient, DBCtrls, Grids, DBGrids, ExtCtrls,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf,
  FireDAC.Stan.Async, FireDAC.DApt, FireDAC.UI.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Phys, FireDAC.VCLUI.Wait, FireDAC.Comp.Client,
  FireDAC.Comp.DataSet, FireDAC.Phys.IB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    FDQuery1: TFDQuery;
    FDQuery2: TFDQuery;
    FDConnection1: TFDConnection;
    FDQuery1ORDERNO: TFloatField;
    FDQuery1CUSTNO: TFloatField;
    FDQuery1SALEDATE: TSQLTimeStampField;
    FDQuery1SHIPDATE: TSQLTimeStampField;
    FDQuery1EMPNO: TIntegerField;
    FDQuery1SHIPTOCONTACT: TStringField;
    FDQuery1SHIPTOADDR1: TStringField;
    FDQuery1SHIPTOADDR2: TStringField;
    FDQuery1SHIPTOCITY: TStringField;
    FDQuery1SHIPTOSTATE: TStringField;
    FDQuery1SHIPTOZIP: TStringField;
    FDQuery1SHIPTOCOUNTRY: TStringField;
    FDQuery1SHIPTOPHONE: TStringField;
    FDQuery1SHIPVIA: TStringField;
    FDQuery1PO: TStringField;
    FDQuery1TERMS: TStringField;
    FDQuery1PAYMENTMETHOD: TStringField;
    FDQuery1ITEMSTOTAL: TFloatField;
    FDQuery1TAXRATE: TFloatField;
    FDQuery1FREIGHT: TFloatField;
    FDQuery1AMOUNTPAID: TFloatField;
    FDQuery2EMPNO: TIntegerField;
    FDQuery2LASTNAME: TStringField;
    FDQuery2FIRSTNAME: TStringField;
    FDQuery2FullName: TStringField;
    FDQuery1EmployeeName: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FDQuery2CalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

uses DataPaths, SharedDMVclU;

{$R *.dfm}

procedure TForm1.FDQuery2CalcFields(DataSet: TDataSet);
begin
  FDQuery2FullName.Value := FDQuery2FirstName.Value + ' ' +
                            FDQuery2LastName.Value;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Connection: TFDConnection;
begin
  Connection := SharedDMVcl.FDConnection;
  Connection.Params.Clear;
  Connection.Params.Add('User_Name=sysdba');
  Connection.Params.Add('Password=masterkey');
  Connection.Params.Add('Protocol=TCPIP');
  Connection.Params.Add('DriverID=IB');
  Connection.Params.Add('Database=' + DataPaths.SamplePath + '\dbdemos.gdb');
  Connection.Open();
  FDQuery1.Connection := Connection;
  FDQuery2.Connection := Connection;
  FDQuery1.Open();
  FDQuery2.Open();
end;

end.
