(* Copyright (c) 2017. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: FireDAC"
     by Cary Jensen

   ISBN-13: 978-1546391272 
   ISBN-10: 1546391274

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: FireDAC"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/FireDACBook
*)
unit datamodule1u;

interface

uses
  System.SysUtils, System.Classes, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Stan.Param,
  FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt, FireDAC.VCLUI.Wait,
  FireDAC.Comp.UI, Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  FireDAC.Phys.IBBase, FireDAC.Phys.IB, FireDAC.VCLUI.Login;

type
  TDataModule1 = class(TDataModule)
    FDConnection1: TFDConnection;
    FDQuery1: TFDQuery;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDPhysIBDriverLink1: TFDPhysIBDriverLink;
    FDGUIxLoginDialog1: TFDGUIxLoginDialog;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModule1: TDataModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses DataPaths;

{$R *.dfm}

procedure TDataModule1.DataModuleCreate(Sender: TObject);
var
  Params: TStrings;
begin
  Params := TStringList.Create;
  try
// This is what it would look like manually
//    Params.Add('Database=localhost:' + DataPaths.IBEmpPath);
//    Params.Add('User_Name=sysdba');
//    Params.Add('Password=masterkey');
//    Params.Add('Pooled=True');
//    Params.Add('Server=127.0.0.1');
//    Params.Add('DriverID=IB');
//    FDManager.AddConnectionDef('IB_EMPLOYEE', 'IB', Params);
    // And here is how it is using the DataPaths unit
    Params.AddStrings(DataPaths.ConnectionParams);
    FDManager.AddConnectionDef('IB_EMPLOYEE', 'IB', Params);
  finally
    Params.Free;
  end;
  FDConnection1.ConnectionDefName := 'IB_EMPLOYEE';
  try
    FDConnection1.Open();
  except
    on Exception do
    begin
      raise Exception.Create('Invalid configuration information. Please update the ' +
                             'DataPaths file with correct database location ' +
                             'information. See the connection information for the ' +
                             'employee.gdb database in the InterBase node of the ' +
                             'data explorer for the database location');
    end;
  end;
end;

end.
